export function floatPrecision(a: number): number {
  if (!isFinite(a)) return 0;
  let e = 1,
    p = 0;
  while (Math.round(a * e) / e !== a) {
    e *= 10;
    p++;
  }
  return p;
}

export function lerp(a: number, b: number, alpha: number) {
  return a + alpha * (b - a);
}

export function clamp(val: number, min: number, max: number) {
  return Math.min(Math.max(val, min), max);
}

export function ensurePrecision(num: number, decimals: number) {
  return Math.round(num * Math.pow(10, decimals)) / Math.pow(10, decimals);
}

export function smoothLerp(min: number, max: number, percent: number) {
  const t = percent * percent * (3 - 2 * percent); // cubic easing function
  return min + t * (max - min);
}
